package eu.mhsl.minecraft.pixelpic;

import eu.mhsl.minecraft.pixelpic.commands.PixelPicCommand;
import eu.mhsl.minecraft.pixelpic.render.render.DefaultScreenRenderer;
import eu.mhsl.minecraft.pixelpic.render.render.Renderer;
import org.bukkit.Bukkit;
import org.bukkit.plugin.java.JavaPlugin;

public final class Main extends JavaPlugin {
    private static Main instance;
    private Renderer screenRenderer;

    @Override
    public void onEnable() {
        instance = this;
        Bukkit.getPluginCommand("pixelPic").setExecutor(new PixelPicCommand());
//
//        Bukkit.getPluginCommand("test2").setExecutor((sender, command, label, args) -> {
//            if(!(sender instanceof Player player)) return false;
//            Bukkit.broadcast(Component.text("HI"));
//
//            Resolution.Pixels pixels = Resolution.Pixels._256P;
//            Resolution.AspectRatio aspectRatio = Resolution.AspectRatio._1_1;
//            Resolution resolution = new Resolution(pixels, aspectRatio);
//            BufferedImage image = screenRenderer.render((Player) sender, resolution);
//            Bukkit.broadcast(Component.text(image.toString()));
//
//            File file = new File(getDataFolder(), "Bild" + ".png");
//            try {
//                getDataFolder().mkdir();
//                ImageIO.write(image, "png", file);
//            } catch (Exception e) {
//                return true;
//            }
//
//            ItemStack map = new ItemStack(Material.FILLED_MAP, 1);
//            MapMeta meta = (MapMeta) map.getItemMeta();
//            MapView mapView = Bukkit.createMap(Bukkit.getWorlds().getFirst());
//            mapView.addRenderer(new ImageMapRenderer(image, 0, 0));
//            meta.setMapView(mapView);
//            map.setItemMeta(meta);
//            player.getInventory().addItem(map);
//
//            ItemStack map2 = new ItemStack(Material.FILLED_MAP, 1);
//            MapMeta meta1 = (MapMeta) map2.getItemMeta();
//            MapView mapView4 = Bukkit.createMap(Bukkit.getWorlds().getFirst());
//            mapView4.addRenderer(new ImageMapRenderer(image, 1, 0));
//            meta1.setMapView(mapView4);
//            map2.setItemMeta(meta1);
//            player.getInventory().addItem(map2);
//
//            ItemStack map3 = new ItemStack(Material.FILLED_MAP, 1);
//            MapMeta meta2 = (MapMeta) map3.getItemMeta();
//            MapView mapView3 = Bukkit.createMap(Bukkit.getWorlds().getFirst());
//            mapView3.addRenderer(new ImageMapRenderer(image, 0, 1));
//            meta2.setMapView(mapView3);
//            map3.setItemMeta(meta2);
//            player.getInventory().addItem(map3);
//
//            ItemStack map4 = new ItemStack(Material.FILLED_MAP, 1);
//            MapMeta meta3 = (MapMeta) map4.getItemMeta();
//            MapView mapView2 = Bukkit.createMap(Bukkit.getWorlds().getFirst());
//            mapView2.addRenderer(new ImageMapRenderer(image, 1, 1));
//            meta3.setMapView(mapView2);
//            map4.setItemMeta(meta3);
//            player.getInventory().addItem(map4);
//
//            player.updateInventory();
//
//            return true;
//        });
    }

    @Override
    public void onDisable() {
    }

    public Renderer getScreenRenderer() {
        if(this.screenRenderer == null) this.screenRenderer = new DefaultScreenRenderer();
        return this.screenRenderer;
    }

    public static Main getInstance() {
        return instance;
    }
}
